; File Name   :	c:\user\hobby\hobby0\z1013 hcbasic\hc-basic-plus-m.asm
; Format      :	Binary file
; Base Address:	0000h Range: 0100h - 2B00h Loaded length: 2A00h

; basiert auf hc-basic-plus.asm
; basiert auf hc-basic-riesa.asm


;kc_basic_m+.z13
;nur MAREK-Routine gendert 

		cpu	z80undoc

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

; Z1013-Arbeitszellen
LAKEY		EQU	0004H		; letztes Zeichen von Tastatur

BUFFA		equ	001Fh		; vom Cursor verdecktes Zeichen
CUPOS		equ	002Bh		; aktuelle Cursorposition
BWS		EQU	0EC00H		; Bildschirm


; BASIC-Arbeitszellen
M0005		EQU	0005H		;
DMA		equ	002Dh		; DMA
PSUM		equ	002Fh		; Prfsumme Kassette
M006E		equ	006Eh		; Bit 7: Repeat; Bit 0:
M006F		equ	006Fh		; Puffer letztes Zeichen von Tastatur

CHARP		equ	0070h		; Spalte 1-32
LINEP		equ	0071h		; Zeile 1-32
M0072		equ	0072h		; WINDOW erste zu rollende Zeile -1 
M0073		equ	0073h		; WINDOW letzte zu rollende Zeile +1 
M0074		equ	0074h		; WINDOW erste zu rollende Spalte -1 
M0075		equ	0075h		; WINDOW letzte zu rollende Spalte +1 

M0077		equ	0077h		; Adr. bergabebereich Typ+Filename
M0079		equ	0079h		; Lnge Vorton
M007A		equ	007Ah
BLNR		equ	007Bh		; Blocknummer gelesen/geschrieben
LBLNR		equ	007Ch		; zu lesende Blocknummer
M007E		equ	007Eh		; Position im Buffer
CONBU		equ	0080h		; DMA-Standard-Buffer DS 80h





;ADRESSEN UND DATEN AUS BASIC KERN
GTOTOK		equ	88h
RSTTOK		equ	8Bh
GSBTOK		equ	8Ch
THNTOK		equ	0A9h
SGNTOK		EQU	0B6H
LODTOK		EQU	0D0H
ELSTOK		equ	0D4h

		include	"basic_8k_kern.inc"


		org	100h

;-----------------------------------------------------------------------------
; read console
;-----------------------------------------------------------------------------

rcons:		bit	7, e		; nur Status-Abfrage?
		jr	z, rcons1
		call	rconb		; sonst Zeichenkette einlesen
		or	a
		jr	z, rcons2	; wenn nix eingegeben wurde
		res	7, e
		jr	rcons2
rcons1:		call	consi
rcons2:		ld	d, a
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

rconb:		push	bc
		push	de
		xor	a
		ld	(4), a
		rst	20h
		db 4
		or	a
		jr	z, rconb2
		call	rconb4
rconb2:		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

; Zeicheneingabe
consi:
consi1:		rst	20h
		db    1			; INCH
; Steuerzeichendecodierung
rconb4:		cp	17h
		ret	nc		; Zeichen >= 17h
		cp	13h		; Pause, ^S
		ret	z
		cp	1		; tab left ^A -> ^Y
		jr	z, loc_21F
		cp	5		; tab right  -> ^X
		jr	z, loc_221
		cp	10h		; ^_
		jr	z, loc_223
		cp	12h		
		ret	c		; Zeichen < 12h
		sub	10h		; INS ^R -> ^Z
loc_21F:	add	a, 5
loc_221:	add	a, 4		; LIST ^T -> ^\.
loc_223:	add	a, 0Fh		; RUN ^U -> ^]
		ret			; CONT ^V -> ^^

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

HLOAD:		call	sub_2AF5
		ld	a, 'N'
		call	0FFF1h
		jr	loc_15A

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

HSAVE:		call	sub_2AF5
		ld	hl, (2BD7h)
		ld	(1Dh), hl
		call	0FFF4h
loc_15A:	ld	hl, (2Bh)
		ld	bc, 0EC00h
		xor	a
		sbc	hl, bc
		ld	b, a
		ld	de, 20h	; ' '
loc_167:	sbc	hl, de
		inc	b
		jr	nc, loc_167
		add	a, l
		add	a, e
		inc	a
		ld	c, a
		ld	(70h), bc
		exx
		ret
; ---------------------------------------------------------------------------

		db    0
		db    0
		db    0

;-----------------------------------------------------------------------------
; JOYST	[i]
; Diese	Funktion dient zur Ermittlung der Spielhebelstellung
; i=1: Spielhebel1, i=2: Spielhebel2
; Der gelieferte Funktionswert ist ein numerischer Wert	von 0..16
;-----------------------------------------------------------------------------

JOYST:		call	SNLY14
		push	hl
		ld	de, SNLY16
		push	de
		call	ARGVL2
		and	a
		jr	z, loc_19C
		cp	3
		jr	nc, loc_19C
		push	af
		call	0FFBBh
		jr	c, loc_19B
		pop	af
		cp	1
		jr	z, loc_197
		ld	c, b
loc_197:	ld	a, c
		jp	POS1
loc_19B:	pop	af
loc_19C:	jp	SNER

;------------------------------------------------------------------------------
; Block auf Kassette ausgeben
;------------------------------------------------------------------------------

KARAM:		di
		xor	a
		ld	(PSUM), a
karam1:		call	kau1b
		cpi
		jp	pe, karam1	; Vorton ausgeben
		call	kautz		; Trennzeichen
		ld	a, (BLNR)
		call	KAUBT
		ld	hl, (DMA)
		ld	b, 80h
karam2:		ld	a, (hl)
		call	KAUBT
		ld	a, (PSUM)
		add	a, (hl)
		ld	(PSUM), a
		inc	hl
		djnz	karam2
		call	KAUBT
		ei
		ret

; ein Byte ausgeben + Trennzeichen
KAUBT:		push	bc
		ld	c, a
		ld	b, 8		; 8 Bit
kaubt1:		rrc	c
		push	af
		call	c, kau1b
		pop	af
		call	nc, kau0b
		djnz	kaubt1
		pop	bc
; Trennzeichen
kautz:		ld	e, 7Bh
		jr	kau1b1
; Ausgabe 0-Bit
kau0b:		ld	e, 18h
		jr	kau1b1
; Ausgabe 1-Bit
kau1b:		ld	e, 36h
kau1b1:		push	de
		ld	a, 80h
		out	(2), a
		call	kau1b2
		pop	de
		xor	a
		out	(2), a
		call	kau1b2
		ret
;
kau1b2:		dec	e
		jr	nz, kau1b2
		ret

;-------------------------------------------------------------------------------
; Block	lesen von Kassette
; Einleseroutine von M. Duchrow
;-------------------------------------------------------------------------------

MAREK:          di
                ld      hl, BLNR
marek0:         ld      b, 22		; 22 Vortne suchen
marek1:         call    LSTOP
                cp      0DCh
                jr      c, marek0
                djnz    marek1
marek2:        	ld      b, 2
marek3:        	ld      c, 13h
                call    sub_247
                jr      c, marek2
                djnz    marek3
                call    IBYTE		; Blocknummer lesen
                ld      hl, (DMA)	; Blockadr.
                ld      b, 80h 		; Anzahl Bytes
                ld      e, 0		; Prfsumme
marek4:         call    IBYTE
                ret     c		; Fehler
                ld      a, e
                add     a, (hl)		; Prfsumme berechnen
                inc     hl
                ld      e, a
                djnz    marek4
                ld      hl, PSUM
                call    IBYTE		; Prfsumme lesen
                ret     c		; Fehler
                ld      a, e
                cp      (hl)		; vergleichen
                ret     z		; in Ordnung
                scf
                ret			; Fehler
; Byte lesen nach (HL)
IBYTE:          ld      d, 9
ibyte1:         ccf
                rr      (hl)
                call    LSTOP
                dec     d
                jr      nz, ibyte1
                ret
;
LSTOP:          ld      c, 12h
                call    sub_247
;
sub_247:        ld      a, 18h
loc_249:        dec     a
                jr      nz, loc_249
                ex      af, af'
                push    de
                cpl
                ld      d, a
loc_250:        dec     c
                in      a, (2)
                xor     d
                and     40h
                jr      z, loc_250
                ld      a, d
                ex      af, af'
                ld      a, c
                cp      30h
                pop     de
                ret

aCMain:         db	"(c)main"

;-------------------------------------------------------------------------------
; Lesen eines Blockes von Kassette
;-------------------------------------------------------------------------------

RRAND:		push	af
rrand1:		pop	af
		call	MAREK
		push	af
		push	hl
		ld	hl, LBLNR
		ld	a, (BLNR)
		cp	(hl)
		pop	hl
		jr	c, rrand1
		jr	nz, rrand2	; Blocknr. zu gro
		pop	af
		jr	c, rrand4	; Lesefehler
		ret
;
rrand2:		ld	hl, aRec_n_f_	; "rec.n.f."
		pop	af
rrand3:		call	PRNST
		scf
		ret

rrand4:		ld	hl, aBadRec_	; "bad rec."
		jr	rrand3

;-----------------------------------------------------------------------------
; PAUSE	[n]
; Die PAUSE-Anweisunmg unterbricht die Ausfhrung eines	Programmes.
; Ist ein Parameter angegeben, dann fr	n Zehntelsekunden.
;-----------------------------------------------------------------------------

PAUSE:		call	TCHAR1		;PARAM.VORH.
		jr	nz, pause3	;PARAMETER VORH.
;
pause1:		call	CSTS		;OHNE PARAMETER
		cp	3		; <STOP> ?
		jr	z, pause2
		cp	1Eh		; <CONT> ?
		jr	nz, pause1
pause2:		ret
;
pause3:		call	EPRVL1		;Argument holen
		push	hl
		ld	hl, 1
pause4:		ld	ix, paus_val
		ld	a, 4
pause5:		ld	c, 84h
pause6:		ld	b, 0Ah
pause7:		add	a, (ix+0)
		djnz	pause7
		dec	c
		jr	nz, pause6
		dec	a
		jr	nz, pause5
		and	a
		ex	de, hl
		sbc	hl, de
		ex	de, hl
		jr	z, pause11	;Zeitende erreicht
		;sonst Test auf Abbruch durch Tastendruck
		push	de
		call	CSTS
		cp	1Eh		; <CONT> ?
		jr	z, pause10
		cp	3		; <STOP> ?
		jr	z, pause10
		pop	de
		jr	pause4
;
pause10:	pop	de
pause11:	pop	hl
		ret

;-----------------------------------------------------------------------------
; BEEP [...] (beliebige	Parameter)
;-----------------------------------------------------------------------------

BEEP:		call	TCHAR1		;PARAMETER VORH.?
		jr	nz, beep1
		push	hl
		ld	hl, (M006E)
		ld	(8), hl
		ld	(9), hl
		call	beep2
		pop	hl
		ret
beep1:		call	TCHAR		;nachfolgende Parameter bergehen
		ret	z
		jr	beep1

beep2:		push	bc
		push	de
		ld	bc, (9)
beep3:		ld	de, (8)
		call	kau1b1
		cp	(ix+0)
		djnz	beep3
		pop	de
		pop	bc
		ret

; =========================================
; BEGINN 8K-KERN
; =========================================

		org	300h

		binclude "basic_8k_kern.bin"

;;ROMTYP	EQU	"ROM" / oder "RAM" + PATCH EOR-Wert
;;BASTYP	EQU	"BASIC_85"
;;CPM	EQU	0
;;	ROMBEG:	EQU	0300H		;INTERPRETERANFANGSADR.
;;	RAMBEG:	EQU	2B00H		;RAMANFANGSADR.
;;	WSP:	EQU	RAMBEG
;;	PRAM:	EQU	WSP+257		;PROGRAMMSPEICHERANFADR.
;;	ZFT:	EQU	0		;WSP<PRAM
;;	BIN0IO:	EQU	1		;BINAERE NULLEN SIND ALS I/O-DATEN MOEGLICH
;;	EXTGO1:	EQU	02300H+3
;;	EXTGO2:	EQU	02303H+3
;;	EXTGO3:	EQU	02306H+3
;;	EXTTAB:	EQU	02309H+3
;;	VERT:	EQU	0230BH+3

; Patch des Kerns
		
		org	300h

		jr	loc_305
		jp	SECST
loc_305:        call    windowf
                ld	a, 40h
                ld      (M006E), a	; kein Repeat


		org	343h
		db	0E7h

		org	22F9h
aRewind:	db 	" REWIND!",0
		db    	0

; =========================================
; ENDE 8K-KERN
; =========================================

;		org	2300h


loc_2303:	jp	ERW1
loc_2306:	jp	ERW2
loc_2309:	jp	ERW3

off_230C:	dw	MNTAB

loc_230E:	jp	VERTEI		; I/O-Verteiler

MNTAB:		db	'I'+80h, "NKEY$"
IKTOK		EQU	0D5H	;inkey$
		db	'J'+80h, "OYST"
JOTOK		EQU	0D6H	;JOYST
		db	'S'+80h, "TRING$"
STROK		EQU	0D7H	;STRING$
		db	'I'+80h, "NSTR"
ISTOK		EQU	0D8H	;INSTR
		db	'R'+80h, "ENUMBER"
RETOK		EQU	0D9H	;RENUMBER
		db	'D'+80h, "ELETE"
DETOK		EQU	0DAH	;DELETE
		db	'P'+80h, "AUSE"
PATOK		EQU	0DBH	;PAUSE
		db	'B'+80h, "EEP"
BETOK		EQU	0DCH	;BEEP
		db	'W'+80h, "INDOW"
WITOK		EQU	0DDH	;WINDOW
		db	'B'+80h, "ORDER"
BOTOK		EQU	0DEH	;BORDER
		db	'I'+80h, "NK"
INTOK		EQU	0DFH	;BORDER
		db	'P'+80h, "APER"
PPTOK		EQU	0E0H	;PAPER
		db	'A'+80h, "T"
ATTOK		EQU	0E1H	;AT
; Zusatz
		db	'H'+80h, "SAVE"
HSAVTOK		EQU	0E2H	;HSAVE
		db	'H'+80h, "LOAD"
HLODTOK		EQU	0E3H	;HLOAD
		db	'P'+80h, "SET"
PSTTOK		EQU	0E4H	;PSET
		db	'P'+80h, "RES"
PRSTOK		EQU	0E5H	;PRES
		db	80h

ADRTB2:		dw	inkey
		dw	JOYST
		dw	STRING
		dw	INSTR

ADRTAB1:	dw	RENUM
		dw	DELETE
		dw	PAUSE
		dw	BEEP
		dw	WINDOW
		dw	BORDER
		dw	BORDER
		dw	BORDER
		dw	AT
		dw 	HSAVE
		dw 	HLOAD
		dw	SNER
		dw	SNER


ERW2:		ld	a, (hl)
		cp	INTOK		;ZULAESSIG?
		ret	c
		cp	PRSTOK+1	;PRINT-ERWEITERUNGEN
		ret	nc		;KEINS FUER PRINT
		cp	ATTOK
		jp	z, AT		;START PRINTAT
		ld	a, (PRTFLG)	;DOPPELTES AUFTRETEN ABBLOCKEN
		and	a
		jr	nz, ERR1
		inc	a
		ld	(PRTFLG),a
		ld	a, (hl)
		cp	INTOK
		jr	z, INPRT
		call	TCHAR
		call	BORDER
		ld	a, (hl)
		cp	';'		;PAPER n ;
		jr	z, CLRG1
		jr	ERR1
;
INPRT:		call	TCHAR
		call	BORDER
		ld	a, (hl)
		cp	';'
		jr	z, CLRG1
		call	CPSTX
		db	','
		cp	PPTOK
		jr	nz, ERR1
		call	TCHAR		;BORDER n,PAPER n;
		call	BORDER
		call	CPSTX
		db	';'

CLREG:		call	PRINT2
		pop	bc
		ret

ERR1:		jp	SNER

CLRG1:		call	TCHAR
		jr	CLREG

;-----------------------------------------------------------------------------
; ERWEITERUNG 3
;* VERTEILER ZU	ZUSAETZLICHEN STANDARTFUNKTIONEN
;* E: <HL> AUF SIGN. ZEICHEN NACH TOKEN
;*    <BC> =<<SP>>  (TOKEN-SGNTOK)*2
;* A: <HL> AUF SIGN. ZEICHEN NACH TOKEN
;-----------------------------------------------------------------------------

ERW3:		ld	a, c			;ZULAESSIG?
		sub	IKTOK-SGNTOK+IKTOK-SGNTOK
		jr	c, ERR1
		cp	ISTOK-IKTOK+ISTOK-IKTOK+1
		jp	nc, ERR1
		ex	de, hl
		ld	bc, ADRTB2		;NEIN
;
		pop	hl
		ld	l, a
		add	hl, bc
		ld	c, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, c
		push	hl
		ex	de, hl
		ret				;ABSPRUNG ZUR ROUTINE

;-----------------------------------------------------------------------------
; RENUMBER [zlnralt1 [,zlnralt2 [,zlnrneu1 [,schrittweite]]]]
; Neunumerieren von Programmzeilen
; zlnralt1,2 - kennzeichnet niedrigste bzw. hchste alte Zeilennummer
; des neu zu numerierenden Programmabschnittes
; Standardwerte: zlnralt1: niedrigste vorhandene Zeilennummer
; zlnralt2 - hchste vorhandene Zeilennummer
; zlnrneu1 - kennzeichnet niedrigste Zeilennummer des neu numerierten
; Programmabschnittes (Standardwert: zlnralt1)
; schrittweite - Differenz zweier aufeinanderfolgender Zeilennummern
; (Standardwert: 10)
;-----------------------------------------------------------------------------

RENUM:		push	hl
		ld	hl, 10
		ld	(DISTAN), hl
		ld	hl, (PSTBEG)
		push	af
		push	hl
		inc	hl
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	(ANF), hl	;ANF=ERSTE ZEILE
		ld	(NANF), hl	;NANF=ANF
		ld	de, (SVARPT)	;DE=PROGR.ENDE
		dec	de
		dec	de
renum1:		pop	hl		;HL=ZEILENADR.
		push	hl		;IN STACK
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a		;HL=NAECHSTE ZADR.
		call	CPREG
		ex	(sp), hl	;HL=ZEILENADR.
					;STACK=NAECHSTE
		jr	nz, renum1
		pop	de
		inc	hl
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	(ENDE), hl	;END=LETZTE ZEILE
		ld	b, 4		;MAX 4 PARAMETER
		pop	af
		ld	hl, ANF
		ex	(sp), hl
renum2:		jr	z, renum5	;KEIN PARAM.MEHR
		call	DCHEX		;WERT IN DE
		push	af
		ld	a, d
		or	e
renum3:		jp	z, FCER		;PARAM.=0
		pop	af
		ex	(sp), hl
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl		;PARAM.EINGETR.
		jr	z, renum5	;KEIN PARAM.MEHR
		push	af
		dec	b
		jr	z, renum4	;ALLE PARAM.
		pop	af
		ex	(sp), hl
		call	CPCOMM		;TEST AUF ","
		jr	renum2
renum4:		pop	af
		jp	nz, SNER	;KEIN ZEILENENDE
renum5:		ld	hl, (ENDE)
		ld	de, (ANF)
		call	CPREG		;END-ANF?
renum6:		jp	c, FCER
		ld	hl, (PSTBEG)
renum7:		call	ZPOIT1		;SUCHE ADR.VON ANF.
		jr	c, renum8	;ZEILE GEFUNDEN
		jr	z, renum3	;PROGR.ENDE
		jr	renum7

renum8:		pop	hl
		push	bc		;ADR.VON ANF.
		ld	de, (ENDE)	;END IN DE
		ld	hl, 0
		ld	(ENDE), hl	;ZEILENZAELER
renum9:		ld	h, b
		ld	l, c
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		ld	a, b
		or	c
		jr	z, renum3	;PROGR.ENDE
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		call	CPREG
		ld	hl, (ENDE)
		inc	hl
		ld	(ENDE), hl
		jr	nz, renum9
		inc	hl
		inc	hl
		add	hl, hl
		inc	hl		;TABL=2*ZEILEN-ANZAHL+5
		ld	de, (SVARPT)	;PROGR.ENDE
		add	hl, de
		jr	c, renum6	;TAB.ZU LANG
		call	TMEMO1
		ld	(SVARPT), hl	;NEUES PROGR.ENDE
		xor	a
		dec	hl
		ld	(hl), a
		dec	hl
		ld	(hl), a
		dec	de
		dec	de
		ex	de, hl
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		dec	a
		ld	(hl), a		;TAB.HAT ZEILENNUMMER 65535
		inc	hl
		ld	(hl), a
		inc	hl
		ex	de, hl		;DE=TABANF.ADR
		ld	hl, (NANF)	;HL=NANF
		ld	(ANF), hl	;NEUE ZEILENNR.
renum10:	pop	hl
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		inc	hl
		push	bc
		ld	bc, ANF
		ld	a, (hl)
		ld	(de), a
		ld	a, (bc)
		ld	(hl), a
		inc	hl
		inc	de
		inc	bc
		ld	a, (hl)
		ld	(de), a
		ld	a, (bc)
		ld	(hl), a		;NEUE ZEILENNR.IN PROGRAMM
					;ALTE ZEILENNR.IN TAB.
		inc	de
		ld	hl, (ANF)
		ld	bc, (DISTAN)
		add	hl, bc
		ld	(ANF), hl	;NEUE ZEILENNR.
		ld	hl, (ENDE)
		dec	hl
		ld	a, h
		or	l
		ld	(ENDE), hl
		jr	nz, renum10
		ld	(de), a
		pop	hl
		ld	hl, (PSTBEG)
		push	hl
renum11:	pop	hl
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		inc	hl
		push	bc
		ld	a, (hl)
		inc	hl
		and	(hl)
		inc	a
		jr	z, renum15
renum12:	inc	hl
renum13:	ld	a, (hl)
		or	a
		jr	z, renum11
		cp	GTOTOK
		jr	z, renum16
		cp	GSBTOK
		jr	z, renum16
		cp	RSTTOK
		jr	z, renum14
		cp	ELSTOK
		jr	z, renum14
		cp	THNTOK
		jr	nz, renum12
renum14:	call	DCHEX1
		ld	a, e
		or	d
		call	nz, RNU14	;VERGLEICH MIT TABELLE
		call	nz, RNU18	;ZAHL AENDERN
		jr	renum13
renum15:	dec	hl
		ld	(SVARPT), hl
		dec	hl
		ld	(hl), a
		dec	hl
		ld	(hl), a
		pop	hl
		pop	hl
		jp	LIN10
renum16:	call	DCHEX1
		ld	a, e
		or	d
		jr	z, renum13
		call	RNU14
		call	nz, RNU18
		ld	a, (hl)
		cp	','
		jr	nz, renum13	;ANWEISUNGSENDE
		jr	renum16
;
RNU14:		push	hl
		push	de
		ld	de, 65535
		call	ZPOIT		;TAB SUCHEN
		pop	de		;DE=ALTE NR.
		inc	bc
		inc	bc
		inc	bc
		inc	bc
		ld	h, b
		ld	l, c		;HL=TAB.ZEIGER
		ld	bc, (NANF)	;BC=NEUE NR.
RNU15:		ld	a, (hl)
		inc	hl
		push	hl
		or	(hl)
		jr	z, RNU17	;TAB.ENDE
		ld	a, (hl)
		dec	hl
		ld	l, (hl)
		ld	h, a
		call	CPREG
		jr	z, RNU16	;ZAHL GEFUNDEN
		ld	hl, (DISTAN)
		add	hl, bc
		ld	b, h
		ld	c, l
		pop	hl
		inc	hl
		jr	RNU15
RNU16:		ld	a, 0FFh
		or	a
RNU17:		pop	hl
		pop	hl
		ret
;
RNU18:		push	bc		;NEUE NR.
		ex	de, hl
		ld	hl, (SVARPT)
		sbc	hl, de
		push	hl		;PROGR.LAENGE
RNU19:		pop	bc
		ld	h, d
		ld	l, e
		dec	de
		ld	a, (de)
		cp	','
		jr	z, RNU20	;VORHER.ZAHL
		cp	03AH
		jr	nc, RNU20	;ZAHL STREICHEN

		push	bc
		push	de
		ldir
		pop	de
		jr	RNU19
RNU20:		ex	de, hl
		pop	de
		push	hl
		push	bc
		xor	a
		ld	b, 98h
		call	SGN1
		call	NUMKON
		pop	bc
		pop	de
		inc	hl
		inc	de
RNU22:		ld	a, (hl)
		or	a
		jr	z, RNU23
		push	bc
		push	hl
		ex	de, hl
		add	hl, bc
		ld	d, h
		ld	e, l
		dec	hl
		lddr
		pop	hl
		ldi
		pop	bc
		jr	RNU22
RNU23:		push	de
		ld	de, (PSTBEG)
		call	LIN11
RNU26:		inc	hl
		ld	a, (hl)
		inc	hl
		or	(hl)
		jr	nz, RNU26
		ex	de, hl
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	de
		inc	de
		ld	(SVARPT), de
		pop	hl
		ld	d, h
		ld	e, l
RNU25:		ld	a, (hl)
		or	a
		inc	hl
		jr	nz, RNU25
		pop	bc
		ex	(sp), hl
		push	bc
		ex	de, hl
		ret


;-------------------------------------------------------------------------------
; INK, PAPER, BORDER
;-------------------------------------------------------------------------------

BORDER:		call	ARGVL1
		ret

;-----------------------------------------------------------------------------
; WINDOW erste_zeile, letzte_zeile, erste_spalte, letzte_spalte
; WINDOW ist gleich WINDOW 0,31,0,31
;-----------------------------------------------------------------------------

WINDOW:		push	hl
		call	DCU		; DCU - Cursor lschen
		pop	hl
		call	TCHAR1		;Pointer auf nchstes signifikantes Zeichen
		jr	z, window3	;wenn keine Parameter
		call	ARGVL1		;Argument holen
		push	af
		call	CPCOMM		;Test auf Komma
		call	ARGVL1		;Argument holen
		push	af
		call	CPCOMM		;Test auf Komma
		call	ARGVL1		;Argument holen
		push	af
		call	CPCOMM		;Test auf Komma
		call	ARGVL1		;Argument holen
		inc	a
		inc	a
		ld	d, a		;d=letzte_spalte+2 
		cp	34		;letzte_spalte+2 < 34 ?
		jr	nc, window2	;nein, d.h. letzte_spalte >= 32
		pop	af
		ld	e, a		;e=erste_spalte
		cp	34		;erste_spalte < 34 ?
		jr	nc, window2	;nein, d.h. erste_spalte >= 34
		pop	af
		inc	a
		inc	a
		ld	b, a		;b=letzte_zeile+2
		cp	34		;letzte_zeile+2 < 34?
		jr	nc, window2	;nein, d.h. letzte_zeile >= 32 
		pop	af
		ld	c, a		;c=erste_zeile 
		cp	34		;erste_zeile < 34 ? 
		jr	nc, window2	;nein, d.h. erste_zeile >= 34
		inc	a
		cp	b		;erste_zeile+1 < letzte_zeile+2 ?
		jr	nc, window2	;nein, d.h. erste_zeile > letzte_zeile
		ld	a, e
		inc	a
		cp	d		;erste_spalte+1 < letzte_spalte+2 ?
		jr	nc, window2	;nein, d.h. erste_spalte > letzte_spalte

window1:	ld	(M0074), de	;E=P3ROL (1. ZU ROLLENDE SPALTE-1)
					;D=P4ROL (LETZTE ZU ROLLENDE SPALTE+1)
		ld	(M0072), bc	;C=P1ROL (1. ZU ROLLENDE ZEILE-1)
					;B=P2ROL (LETZTE ZU ROLLENDE ZEILE+1)
		ld	d, c		;Cursor auf Fensteranfang
		inc	d
		inc	e
		push	hl
		call	SETCU
		pop	hl
		ret
window2:	jp	SNER		;Ausgabe SN-ERROR
windowf:	push	hl
		call	DCU
		pop	hl
window3:	ld	bc, 2100h	;Zeilen 1 - 20h=32
		ld	de, 2100h	;Spalten 1 - 20h=32
		jr	window1
		
;-----------------------------------------------------------------------------
; INKEY$
; Ermittlung einer Tastenbettigung
;-----------------------------------------------------------------------------

INKEY:		push	hl		;ZEILENZEIGER RETTEN
		call	CSTS		;EINGABE?
		jr	nz, inkey2
		push	af
		ld	a, 1
		call	STADTB		;VARIABLE BELEGEN
		pop	af
		ld	hl, (STRDAT+2)	;WERT EINTRAGEN
		ld	(hl), a
inkey1:		jp	SLEN3
inkey2:		xor	a
		call	STADTB		;STRING MIT LAENGE 0
		jr	inkey1

;-----------------------------------------------------------------------------
; INSTR	(x$,y$)
; Diese	Anweisung liefert die Position des ersten Auftretens des
; Zeichenkettenausdruckes x$ im	Zeichenkettenausdruck y$.
; Ist x$ nicht in y$ enthalten,	so den Wert 0.
; Der Funktionswert ist	ein numerischer	Wert zwischen 0	und 255.
;-----------------------------------------------------------------------------

INSTR:		call	SNALY6		;PARAMETER1
		call	CPCOMM		;Test auf Komma
		push	hl
		call	LEN1		;STRING LAENGE
		jr	z, instr7	;Fehler: X$ ist Leerstring
;
		ld	b, a		;B=Lnge X$
		inc	hl
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)		;DE=Adresse X$
		pop	hl
;
		push	de
		push	bc
		call	SNALY		;PARAMETER 2
		call	CPBRGT		;Test auf rechte Klammer
		pop	bc
		pop	de
;
		push	hl
;
		push	de
		push	bc
		call	LEN1		;STRING LAENGE
		jr	z, instr7
		inc	hl
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, c		;HL=Adresse Y$
		pop	bc
		ld	c, a		;C=Lnge Y$
		pop	de
;		
		push	hl
instr1:		push	bc
		push	de
		ld	a, (de)
instr2:		cp	(hl)		;erstes Zeichen gleich?
		jr	z, instr8
		inc	hl
		dec	c
		jr	nz, instr2
;
instr3:		xor	a		;nicht gefunden -> Rckgabewert 0
		pop	hl
		pop	hl
		pop	hl
instr5:		ld	de, SNLY16
instr6:		push	de
		jp	POS1
;
instr7:		jp	FCER		;FC ERROR
;
instr8:		inc	hl
		push	hl
		dec	hl
instr9:		inc	hl
		dec	c
		jr	z, instr10	;wenn am Ende von Y$ angekommen
		inc	de
		dec	b
		jr	z, instr11	;wenn am Ende von X$ angekommen
		ld	a, (de)
		cp	(hl)		;Vergleich nchstes Zeichen
		jr	z, instr9	;wenn gleich
;
		pop	hl
		pop	de
		ld	a, c
		pop	bc
		ld	c, a
		jr	instr1		;sonst weitersuchen
;
instr10:	inc	de		;Ende von Y$ erreicht
		dec	b		;auch Ende von X$ erreicht?
		pop	hl
		jr	nz, instr3	;nicht gefunden -> Rckgabewert 0
		jr	instr12		;wenn gefunden
;X$ in Y$ gefunden
instr11:	pop	hl
instr12:	pop	de
		pop	de
		pop	de
		and	a
		sbc	hl, de
		ld	a, l		; Rckgabewert
		jr	instr5

;-----------------------------------------------------------------------------
;STRING$ (i,j$)
; Die Funktion liefert eine Zeichenkette, die durch i-fache Wiederholung des
; Zeichenkettenausdrucks j$ entsteht. i	kann Werte zwischen 0 und 255 (einschlielich)
; annehmen. Der	Zeichenkettenausdruck, der durch die Funktion STRING$ geliefert	wird,
; darf hchstens 255 byte lang sein.
;-----------------------------------------------------------------------------

STRING:		call	CPSTX		;'('?
		DB	'('
		CALL	ARGVL1		;PARAMETER 1
		PUSH	AF		;WERT RETTEN
		call	CPCOMM		;KOMMA?
		call	SNALY		;PARAMETER 2 (STRING)
		call	CPBRGT		;')'?
		pop	af
		push	hl		;ZEILENZEIGER
		push	af
		call	LEN1		;LAENGE UND ADRESSE PARAM.2
		inc	hl		;IN A UND HL
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		pop	bc		;PARAM.1 (WIEDERHOLFAKTOR)
		push	bc
		push	af
		push	de
		ld	c, a		;LAENGE NEUER STRING BERECHNEN
		xor	a
		cp	c
		jr	z, string2
		cp	b
		jr	z, string2
		ld	a, c
		dec	b
		jr	z, string2
string1:	add	a, c
		jr	c, string6
		djnz	string1
string2:	ld	b, a		;LAENGE IN A UND BC
		ld	c, 0
		push	bc
		call	STROP		;PLATZ IN STRINGPOOL RESERVIEREN
					;ADR.NEUER STRING IN DE
		pop	bc		;LAENGE NEUER STRING IN BC
		pop	bc		;ADR.ALTER STRING HOLEN
		push	bc
		call	SADTB1		;EINTRAGEN IN STRDAT.
		pop	hl
		ex	(sp), hl	;ALTE LAENGE IN H
		ld	a, h
		pop	hl
		ex	(sp), hl
		ld	l, a
		inc	h
string3:	dec	h		;STRING EINTRAGEN
		push	hl
		push	bc
		jr	z, string4
		call	STRMV1		;String eintragen in Stringpool
		pop	bc
		pop	hl
		jr	string3
string4:	pop	bc
		pop	hl
		pop	de		;FERTIG ABSCHLUSS
		call	STRZS3
		jp	SLEN3
string6:	ld	e, 28
		jp	ERROO

;-----------------------------------------------------------------------------
;PRINT AT (Zeile,Spalte);Ausdruck ,Ausdruck ...
;Die angegebenen Ausdrcke werden auf dem Bildschirm an	der durch Zeile	und Spalte
;festgelegten Position hintereinander angezeigt.
;Die Parameter Zeile (0	bis 23)	und Spalte (0 bis 39) sind ganzzahlige Ausdrcke.
;-----------------------------------------------------------------------------

AT:		ld	a, (PRTFLG)
		bit	1, a
		set	1, a		;PRINTFLAG SETZEN
		ld	(PRTFLG), a
		jr	nz, at1		;FEHLER
		call	TCHAR
		call	CPSTX		;'('?
		db	'('
		call	ARGVL1		;Parameter1: Zeile
		push	af
		call	CPCOMM		;KOMMA?
		call	ARGVL1		;Parameter2: Spalte
		push	af
		call	CPBRGT		;')'?
;
		call	CPSTX		;'('?
		db ';'
		pop	af
		ld	c, a		;C=Spalte
		pop	af
		push	hl
		ld	b, a		;B=Zeile
		ld	a, b
		cp	32		;Zeile<32?
		jr	nc, at1		;Nein -> SN ERROR
		ld	a, c
		cp	32		;Spalte<32?
		jr	c, at2		;ja
at1:		jp	SNER		;SN ERROR
at2:		ld	l, 0
		ld	h, l		;HL=0
		ld	d, l
		ld	e, 32		;Lnge Bildschirmzeile
		inc	b
		dec	b
		jr	z, at4		;wenn B=0
at3:		add	hl, de		;HL=Zeile*40
		djnz	at3
;
at4:		ld	e, c		;Spalte
		add	hl, de		;HL=Offset im BWS
		ld	de, BWS
		add	hl, de
		ld	d, h
		ld	e, l		;DE=Position im BWS
		pop	hl
		push	de
at5:		cp	IKTOK		;0D5h
		jr	c, at6
		ld	a, (EXTFLG)
		and	a
		jr	z, at6
		call	loc_2306
at6:		call	SNALY
		push	hl
		ld	a, (DATYPE)
		or	a
		jr	nz, at7
		call	NUMKON
		call	SLEN0
		ld	(hl), 20h 	; ' '
		ld	hl, (WRA1)
		inc	(hl)
at7:		call	STRZS1
		call	OPLAD
		pop	hl
		pop	ix
		inc	e
at8:		dec	e
		jr	z, at9
		ld	a, (bc)
		call	at11
		jr	nc, at9
		ld	(ix+0),	a
		inc	ix
		inc	bc
		jr	at8
at9:		call	TCHAR1
		jr	nz, at10
		pop	bc
		ret
at10:		call	CPCOMM		;KOMMA?
		push	ix
		jr	at5
;
at11:		push	hl
		push	ix
		pop	hl
		push	de
		ld	de, 0F000h
		and	a
		sbc	hl, de
		pop	de
		pop	hl
		ret

aVerifyYN:	db 0Dh,0Ah
		db "VERIFY?  ",0

ERR1j:		jp	SNER


;-----------------------------------------------------------------------------
; DELETE zeilennummer1 [,zeilennummer2]
; Streichen von	Programmzeilen
; zeilennummer1,2 - kennzeichnet niedrigste bzw. hchste zu streichende	BASIC-Zeile
;-----------------------------------------------------------------------------

DELETE:		ret	z
		call	DCHEX
		jp	z, LIN13
		call	CPCOMM		;KOMMA?
		push	de
		call	DCHEX
		pop	hl
		ret	nz
		ex	de, hl
		push	hl
		call	ZPOIT
delete1:	jp	nc, LIN15
		pop	de
		push	af
		push	bc
		call	ZPOIT1
		jr	nc, delete1
		pop	bc
		jp	LIN6

;-----------------------------------------------------------------------------
; IO-Schnittstelle
; Das zu bertragende Zeichen steht entweder in	den Registern A
; und D	oder wird in diesen erwartet, Die Kanalinformation steht
; in Register E:
;
;  bit0		   0	- Eingabekanal
;		   1	- Ausgabekanal
;     1	\	   00	- Konsolenkanal
;     2	/	   01	- Magnetbandkassette
;		   10	- Drucker
;		   11	- frei
;     3			  Initialisierungsbit
;     4		   0	- E/A im ASCII-Code
;		   1	- E/A im internen Code
;     5		   1	- Rcksprung zum Steuerprogramm
;     6			  Endebit
;     7			  immediate-return-bit
;
;-----------------------------------------------------------------------------

VERTEI:		bit	5, e		; BYE ?
		jp	nz, 38h		; dann Systemneustart
		ld	(M0077), hl
		push	hl		; HL sichern
		ld	hl, vertei1	; Rckehradresse kellern
		push	hl
		ld	a, e
		and	7
		sla	a
		add	a, lo(vertab)
		ld	l, a
		ld	a, 0
		adc	a, hi(vertab)
		ld	h, a
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)		; Start der IO-Routine
vertei1:	pop	hl		; HL restaurieren
		ret			; und zurck zum BASIC

;-----------------------------------------------------------------------------
; ERWEITERUNG 1
;*  E: <B>:TOKEN-LODTOK
;*     <HL> :  AUF TOKEN
;*  A:   <<SP>>: STARTADRESSE ROUTINE
;*     <HL>:  AUF TOKEN
;
;-----------------------------------------------------------------------------

ERW1:		ld	a, b
		sub	RETOK-LODTOK
		jr	c, ERR1j
		cp	PRSTOK-RETOK+1
		jr	nc, ERR1j
		rlca
		ld	c, a
		ld	b, 0
		ex	de, hl
		ld	hl, ADRTAB1
		add	hl, bc
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		push	bc
		ex	de, hl
		jp	TCHAR

vertab:		dw	rcons		; Kanal#0: Console
		dw	conso
		dw	rtape		; Kanal#1: Tape
		dw	wtape
		dw	IOERR		; Kanal#2: Drucker
		dw	listo
		dw	IOERR		; Kanal#3: frei
		dw	IOERR

;-----------------------------------------------------------------------------
; console output
;-----------------------------------------------------------------------------

conso:		push	de
		push	bc
		ld	c, d		; auszugebendes Zeichen
		push	hl
		call	cons0
		pop	hl
		pop	bc
		pop	de
		res	7, e
		ret

;-----------------------------------------------------------------------------
; write	tape
;-----------------------------------------------------------------------------
;BASIC-Kopf:
; 3 Byte Dateityp (D3, D4, D5 bzw. D7, D8, D9)
; 8 Byte Dateiname, wenn krzer, dann mu mind.	1 Leerzeichen folgen
; 2 Byte Adresse1
; 2 Byte Adresse2

wtape:		push	hl
		push	bc
		push	de
		bit	3, e		; init?
		jr	z, wtape2	; nein, also Byte in Buffer schreiben
;Initialisierung
		ld	hl, (M0077)
		ld	bc, 0Bh		; 3 Byte Dateityp + 8 Byte Dateiname
		inc	hl
		inc	hl
		ld	a, 0D5h		; CLIST
		cp	(hl)		; ist 3. Byte = CLIST-Kennung?
		push	de
		ld	de, 0A0h	; Lnge Vorton
		jr	nz, wtape1
		ld	de, 400h	; Bei CLIST mehr Zeit zwischen den Blcken lassen
wtape1:		ld	(M0079), de	; Lnge Vorton merken
		ld	de, CONBU	;  Dateityp + Dateiname nach STDMA-Buffer kopieren
		ldir
		pop	de
		ld	hl, BLNR	; 1. Block hat Nummer 0
		ld	(hl), 0
		ld	hl, M007E	; Position im Buffer
		ld	(hl), 0Ch	; mit 0Ch initialisieren (nach Dateityp+Dateiname)
		ld	hl, CONBU+0Bh	; Offs. 3 Byte Dateityp + 8 Byte Dateiname
		ld	(hl), d		; 1. auszugebendes Zeichen
		jp	wtape9
; nchstes Zeichen in Buffer schreiben
wtape2:		ld	hl, CONBU
		ld	a, (M007E)	; Position im Buffer
		ld	c, a
		ld	b, 0
		add	hl, bc
		inc	a
		ld	(M007E), a
		ld	(hl), d		; Zeichen in Buffer schreiben
		bit	6, e		; Ende?
		jr	nz, wtape3	; Sprung wenn Endebit gesetzt
		cp	80h		; oder Buffer voll?
		jr	nz, wtape9	; sonst raus hier
; Block auf Kassette schreiben
wtape3:		ld	hl, CONBU
		ld	(DMA), hl	; DMA setzen
		push	de
		ld	a, (BLNR)
		or	a		; 1. Block?
		ld	bc, 1770h	; dann langer Vorton
		jr	z, wtape4
		ld	bc, (M0079)	; sonst gewhlte Vortonlnge
wtape4:		inc	a
		ld	(BLNR), a	; Blocknummer erhhen
		call	KARAM		; Block schreiben
		ld	hl, M007E	; Position im Buffer
		ld	(hl), 0		; zurcksetzen fr nchsten Block
		call	OSPAC		; Leerzeichen ausgeben
		pop	de
		bit	6, e		; Ende?
		jp	z, rtape4
; Verify
		ld	hl, aVerifyYN	; "\r\nVERIFY (Y/N)? "
		call	PRNST
		call	consi
		cp	'Y'
		jr	nz, wtape9	; Sprung, wenn kein Verify gewnscht ist
		ld	hl, aRewind	; " REWIND!"
		call	PRNST
		call	consi
		ld	d, '*'
		call	conso
		ld	a, (BLNR)
		ld	b, a		; Anzahl der zu verifizierenden Blcke
wtape5:		push	bc
;
wtape6:		call	MAREK		; Block lesen
		jr	nc, wtape7	; weiter wenn alles ok
		call	consi		; bei Lesefehlern warten auf Tastendruck
		cp	0Dh		; <ENTER>?
		jr	z, wtape6	; dann Block erneut lesen
		cp	3		; <STOP>?
		jr	z, rtape6	; dann Abbruch -> IOERR
wtape7:		call	CSTS
		cp	3		; <STOP>?
		jr	z, rtape6	; dann Abbruch -> IOERR
		call	OSPAC
		pop	bc
		djnz	wtape5		; bis alle Blcke gelesen
wtape8:		pop	af
wtape9:		pop	de
		pop	bc
		pop	hl
		res	7, e
		res	3, e
		ld	d, a
		ret
;-----------------------------------------------------------------------------
; read from tape
;-----------------------------------------------------------------------------

rtape:		push	hl
		push	bc
		push	de
		bit	6, e		; Ende?
		jr	nz, wtape9	; dann abbrechen
		bit	3, e		; Init?
		jr	z, rtape7	; nein, Daten einlesen
; Init
		ld	hl, CONBU
		ld	(DMA), hl	; DMA auf STDMA setzen
		xor	a
		ld	(M007E), a	; Position im Buffer = 0
		ld	hl, LBLNR	; 1. zu lesende Blocknummer = 1
		ld	(hl), 1
rtape1:		call	RRAND		; Lesen eines Blockes von Kassette
		jr	nc, rtape3	; wenn kein Fehler
rtape2:		call	consi
		cp	3		; <STOP>?
		jr	nz, rtape1	; nein, dann erneuter Leseversuch
		jr	rtape6
rtape3:		ld	a, (BLNR)
		dec	a
		jr	nz, rtape2	; erneuter Leseversuch, wenn nicht Block Nr. 1
; 1. Block gelesen
		call	OSPAC		; Leerzeichen ausgeben
		call	thead
		ld	hl, M007E	; Position im Buffer
		ld	(hl), 0Ch	; mit 0Ch initialisieren (nach Dateityp+Dateiname)
		ld	hl, CONBU+0Bh	; Offs. 3 Byte Dateityp + 8 Byte Dateiname
		ld	a, (hl)		; 1. Zeichen
rtape4:		push	af
rtape5:		call	CSTS
		cp	3		; <STOP>?
		jr	nz, wtape8	; zurck zu BASIC
rtape6:		jr	rtapef		; IOERR
; Daten	einlesen
rtape7:		ld	hl, CONBU
		ld	a, (M007E)	; Position im Buffer
		ld	c, a
		ld	b, 0
		add	hl, bc
		ld	a, (hl)		; nchstes Zeichen holen
		push	af
		ld	a, c
		inc	a
		ld	(M007E), a	; Position im Buffer
		cp	80h		; Bufferende?
		jr	nz, wtape8	; nein, dann mit Zeichen zurck zu BASIC
		ld	a, (LBLNR)	; ja, dann Blocknummer erhhen
		inc	a
		ld	(LBLNR), a
rtape8:		call	RRAND		; Lesen eines Blockes von Kassette
		jr	nc, rtape10	; wenn ohne Lesefehler
rtape9:		call	consi
		cp	3		; <STOP>?
		jr	nz, rtape8	; nein, dann erneuter Leseversuch
		jr	rtapef		; sonst IOERR
rtape10:	ld	hl, LBLNR	; Vergleich gelesene und zu lesende Block Nr.
		ld	a, (BLNR)
		cp	(hl)
		jr	c, rtape8
		jr	nz, rtape9	; erneuter Leseversuch, wenn nicht Block Nr.
		call	OSPAC
		ld	hl, M007E	; Position im Buffer
		ld	(hl), 0		; zurcksetzen fr Block
		jr	rtape5		; und Block abarbeiten

; Programmnamen	anzeigen
thead:		ld	hl, CONBU
		ld	b, 0Bh		; 3 Byte Dateityp + 8 Byte Dateiname
thead1:		ld	d, (hl)
		call	conso		; anzeigen
		inc	hl
		djnz	thead1
;Programmnamen vergleichen
		ld	hl, (M0077)	; Vergleich mit zu lesendem Dateinamen
		ld	bc, 0Ch		; vergleiche rckwrts
		add	hl, bc
		ld	b, 0Bh		; 3 Byte Dateityp + 8 Byte Dateiname
		ld	de, CONBU+0Ah
thead2:		ld	a, (de)
		cp	(hl)
		dec	de
		jr	nz, thead4	; wenn ungleich
thead3:		dec	hl
		djnz	thead2
		ret
;
thead4:		sub	4		; Test auf gesetzte Copybit
		cp	(hl)		; wenn dann immer noch ungleich, so
		jr	nz, rtapef	; Datei nicht gefunden
		ld	a, 0FFh		; sonst DATFLG setzen
		ld	(DATFLG), a
		jr	thead3		; und weiter vergleichen
;
rtapef:		jp	IOERR


;-------------------------------------------------------------------------------
; Leerzeichen ausgeben 
;-------------------------------------------------------------------------------

OSPAC:		ld	c, ' '
cons0:	jr	cons

;-------------------------------------------------------------------------------
; VERTEI Druckerausgabe
;-------------------------------------------------------------------------------

listo:		ld	a, c
		call	0FFE8h		; DRAKK
		ret
		
		db	0

;-------------------------------------------------------------------------------
; Zeichen C ausgeben
;-------------------------------------------------------------------------------

cons:		ld	hl, consret
		push	hl
		call	DCU
		ld	a, c
		sub	8
		ret	c
		jr	z, chr_08	; cursor left
		dec	a
		jr	z, chr_09	; cursor rechts
		dec	a
		jr	z, chr_0a	; cursor runter
		dec	a
		jr	z, chr_0b	; cursor hoch
		dec	a
		jr	z, chr_0c	; cls
		dec	a
		jr	z, chr_0d	; enter
		ld	(hl), c
		jr	chr_09
; CLS
chr_0c:		ld	a, (M0072)	; erste zu rollende Zeile -1
		inc	a
		ld	(LINEP), a
		ld	b, a
		ld	a, (M0073)	; letzte zu rollende Zeile +1
		sub	b
		ld	b, a
loc_2A02:	push	bc
		call	scrup
		pop	bc
		djnz	loc_2A02
; ENTER
chr_0d:		ld	a, (M0074)	; erste zu rollende Spalte -1
		ld	(CHARP), a
; Cursor rechts
chr_09:		ld	hl, CHARP
		ld	de, M0075	; letzte zu rollende Spalte +1
		inc	(hl)
		ld	a, (de)
		cp	(hl)
		ret	nz		; wenn noch in alter Zeile
		dec	de
		ld	a, (de)
		inc	a
		ld	(hl), a
; Cursor runter
chr_0a:		ld	hl, LINEP
		inc	(hl)
		ld	a, (M0073)	; letzte zu rollende Zeile +1
		dec	a
		cp	(hl)
		ret	nc		; wenn nicht letzte Zeile
		ld	(hl), a
		jr	scrup		; Scroll Up

; Cursor links
chr_08:		ld	hl, CHARP
		ld	de, M0074	; erste zu rollende Spalte -1
		dec	(hl)
		ld	a, (de)
		cp	(hl)
		ret	nz		; wenn noch in alter Zeile
		inc	de
		ld	a, (de)
		dec	a
		ld	(hl), a
; Cursor hoch
chr_0b:		ld	hl, LINEP
		dec	(hl)
		ld	a, (M0072)	; erste zu rollende Zeile -1
		cp	(hl)
		ret	c		; wenn nicht erste Zeile
		inc	a
		ld	(hl), a
		jr	scrdn		; Scroll Down
; Berechnung absolute Cursorposition
consret:	ld	hl, CHARP
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		ld	hl, BWS-32
		ld	de, 32		; Lnge Bildschirmzeile
consret1:	add	hl, de
		djnz	consret1
		dec	bc
		add	hl, bc
		ld	(CUPOS), hl
		ld	a, (hl)
		ld	(BUFFA), a
		ld	(hl), 0FFh	; Cursor setzen, FFh = Cursorzeichen
		ret

;-------------------------------------------------------------------------------
; Cursor lschen
;-------------------------------------------------------------------------------

DCU:		ld	hl, (CUPOS)
		ld	a, (BUFFA)
		ld	(hl), a		; Zeichen unter Cursor setzen
		ret

;-------------------------------------------------------------------------------
; Scrollen up/down
;-------------------------------------------------------------------------------

scrup:		db	3Eh		; mit nachfolgender Anweisung LD A, 0AFh (<> 00)
scrdn:		xor	A		; A := 0
		push	af
		ld	hl, BWS-32
		ld	de, 32		; Lnge BWS-Zeile
		ld	a, (M0072)	; erste zu rollende Zeile -1
		inc	a
		ld	c, a
		ld	a, (M0073)	; letzte zu rollende Zeile +1
		dec	a
		ld	b, a
		pop	af
		push	bc
		or	a
		jr	z, scroll1	; wenn A = 0 war (Eintritt ber scrdn)
		ld	b, c
scroll1:	add	hl, de
		djnz	scroll1
		pop	bc
		push	af
		ld	a, b
		sub	c
		jr	z, scroll5
		ld	b, a
scroll2:	pop	af
		push	hl
		or	a
		jr	z, scroll3
		add	hl, de
		jr	scroll4
scroll3:	sbc	hl, de
scroll4:	pop	de
		push	af
		push	hl
		push	bc
		ld	a, (M0074)	; erste zu rollende Spalte -1
		ld	b, 0
		ld	c, a
		add	hl, bc
		ex	de, hl
		add	hl, bc
		ex	de, hl
		inc	c
		ld	a, (M0075)	; letzte zu rollende Spalte +1 
		sub	c
		ld	c, a
		ldir
		pop	bc
		pop	hl
		ld	de, 32
		djnz	scroll2
scroll5:	pop	af
		ex	de, hl
		ld	hl, (M0074)	; erste zu rollende Spalte -1
		ld	a, h
		inc	l
		ld	h, 0
		ld	b, h
		sub	l
		ld	c, a
		add	hl, de
		ld	d, h
		ld	e, l
		dec	hl
		dec	c
		ret	z
		ld	(hl), ' '
		ldir
		ret

;-------------------------------------------------------------------------------
; Cursor auf relative Cursorposition DE setzen
;-------------------------------------------------------------------------------

SETCU:		ld	hl, CHARP
		ld	(hl), e
		inc	hl
		ld	(hl), d
		jp	consret

;-------------------------------------------------------------------------------
; Ausgabe Zeichenkette bis 00-Byte
;-------------------------------------------------------------------------------

PRNST:		ld	a, (hl)
		or	a
		ret	z
		ld	d, a
		call	conso
		inc	hl
		jr	PRNST

;-------------------------------------------------------------------------------
; 
;-------------------------------------------------------------------------------

aBadRec_:	db 0Dh,0Ah
		db "bad rec."
paus_val:	db 0
aRec_n_f_:	db 0Dh,0Ah
		db "rec.not f.",0
		
		db 0

;-------------------------------------------------------------------------------
; 
;-------------------------------------------------------------------------------

sub_2AF5:	exx
		ld	iyu, 'B'
		ld	hl, 2BC0h
		ld	(1Bh), hl
		ret

	end
